# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field
from phrasetms_client.models.job_part_ready_references import JobPartReadyReferences
from phrasetms_client.models.pseudo_translate_action_dto_v2 import PseudoTranslateActionDtoV2

class PseudoTranslateWrapperDto(BaseModel):
    """
    PseudoTranslateWrapperDto
    """
    job_parts: JobPartReadyReferences = Field(..., alias="jobParts")
    pseudo_translate: PseudoTranslateActionDtoV2 = Field(..., alias="pseudoTranslate")
    __properties = ["jobParts", "pseudoTranslate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PseudoTranslateWrapperDto:
        """Create an instance of PseudoTranslateWrapperDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of job_parts
        if self.job_parts:
            _dict['jobParts'] = self.job_parts.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pseudo_translate
        if self.pseudo_translate:
            _dict['pseudoTranslate'] = self.pseudo_translate.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PseudoTranslateWrapperDto:
        """Create an instance of PseudoTranslateWrapperDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PseudoTranslateWrapperDto.parse_obj(obj)

        _obj = PseudoTranslateWrapperDto.parse_obj({
            "job_parts": JobPartReadyReferences.from_dict(obj.get("jobParts")) if obj.get("jobParts") is not None else None,
            "pseudo_translate": PseudoTranslateActionDtoV2.from_dict(obj.get("pseudoTranslate")) if obj.get("pseudoTranslate") is not None else None
        })
        return _obj

